"""
A script to generate the schemas for the GA4GH protocol. We download
the Avro definitions of the GA4GH protocol and use it to generate
the Python class definitions in ga4gh/_protocol_definitions.py.
"""

from __future__ import division, print_function, unicode_literals

import glob
import json
import os.path
import re
import sys
import tarfile
import textwrap

import avro.schema

from protocols.util.dependency_manager import DependencyManager
from protocols_utils.utils.makedir import makedir

from . import utils

HEADER_COMMENT = """
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""


class SchemaClass(object):
    """Class to convert an Avro JSON definition of a GA4GH type into the corresponding Python class."""

    def __init__(self, sourceFile, dependencies):
        self.sourceFile = sourceFile
        with open(sourceFile) as sf:
            schemastr = sf.read()

        self.schema = avro.schema.parse(schemastr)
        self.schemaSource = json.loads(schemastr)
        self.name = self.schema.name
        self.dependencies = dependencies

    def getFields(self):
        """
        Returns the list of avro fields sorted in order of name.
        """
        return sorted(self.schema.fields, key=lambda f: f.name)

    def isSearchRequest(self):
        """Returns True if the class we are converting is a subclass of
        SearchRequest, and False otherwise.

        :return: Whether the model is a Search request
        :rtype: bool
        """
        return re.search("Search.+Request", self.name) is not None

    def isSearchResponse(self):
        """Returns True if the class we are converting is a subclass of
        SearchResponse, and False otherwise.

        :return: Whether the model is a Search response
        :rtype: bool
        """
        return re.search("Search.+Response", self.name) is not None

    def getValueListName(self):
        """Returns the name of the list used to store values in a page for
        a SearchRequest subclass.

        :return: Name of list
        :rtype: str
        """
        assert self.isSearchResponse()
        names = [field.name for field in self.getFields()]
        # We assume that there are exactly two fields in every
        # SearchResponse: nextPageToken and the value list.
        names.remove("nextPageToken")
        assert len(names) == 1
        return names[0]

    def get_default(self, field):
        """Returns the default for the provided field.

        :param field: Avro field
        :type field:
        :return: Default
        :rtype: Any
        """
        if field.type.type == "string" or field.type.type == "enum":
            if field.has_default and field.default is not None:
                return '"{}"'.format(field.default)
        elif isinstance(field.type, avro.schema.UnionSchema) and "null" in [
            t.type for t in field.type.schemas
        ]:
            return "None"
        elif field.has_default and field.default is not None:
            if isinstance(field.default, dict):
                return "dict"
            if isinstance(field.default, list):
                return "list"
            return field.default
        return None

    def getEmbeddedTypes(self):
        """
        Returns the set of embedded types in this class.
        """

        return_types = (avro.schema.RecordSchema, avro.schema.EnumSchema)

        def check_type(avro_type):
            if isinstance(avro_type, avro.schema.ArraySchema):
                return check_type(avro_type.items)
            elif isinstance(avro_type, avro.schema.MapSchema):
                return check_type(avro_type.values)
            elif isinstance(avro_type, return_types):
                return avro_type
            elif isinstance(avro_type, avro.schema.UnionSchema):
                el = [el for el in avro_type.schemas if el.type != "null"]
                # only expect one type here...
                return check_type(el[0])

        ret = {}
        if isinstance(self.schema, avro.schema.RecordSchema):
            for field in self.getFields():
                avro_type = check_type(field.type)
                if avro_type:
                    ret[field.name] = avro_type
        return ret

    def parse_doc(self, doc):
        """Returns list of lines parsed to be compatible with RST

        :param doc: Doc string
        :type doc: str
        :return: Parsed lines
        :rtype: list[str]
        """

        out = []

        for point in re.findall("(\*(.)*\n\s*[^\*]*)", doc):
            replacement = " ".join(p.strip() for p in point[0].splitlines())
            doc = doc.replace(point[0], "\n" + replacement.strip() + "\n")

        for line in doc.splitlines():
            stripped = line.strip()
            if stripped and stripped[0] in ["-", "=", "."]:
                continue
            out.append(line.strip().replace("`", "'"))

        return out

    def get_formatted_name(self, schema, extension=""):
        return "{}_{}{}".format(schema.name.lower(), schema.type, extension)

    def get_schema(self, avro_type):
        file_name = os.path.join(
            os.path.dirname(self.sourceFile),
            self.get_formatted_name(avro_type, ".avsc"),
        )
        if os.path.exists(file_name):
            embeddedclass = self.__class__(file_name, self.dependencies)
            avro_type = embeddedclass.schema
        return avro_type


class PyClass(SchemaClass):
    def writeRequiredFields(self, handle):
        """Writes a string encoding the set of required fields (i.e those
        fields that do not have a default value)

        :param handle: File handle to output
        :type handle:
        """
        fields = []
        for field in self.getFields():
            if not field.has_default and not (
                isinstance(field.type, avro.schema.UnionSchema)
                and "null" in [t.type for t in field.type.schemas]
            ):
                fields.append(field)
        if len(fields) < 1:
            self._writeWithIndent("requiredFields = {}", handle, numNewlines=2)
        else:
            self._writeWithIndent("requiredFields = {", handle)
            for field in fields:
                string_ = '"{0}",'.format(field.name)
                self._writeWithIndent(string_, handle, 2)
            self._writeWithIndent("}", handle, numNewlines=2)

    def get_type_for_docstring(self, schema_class):
        primatives = {"string": "str", "int": "int", "long": "int", "null": "None"}
        if isinstance(schema_class, avro.schema.ArraySchema):
            return "list[{}]".format(self.get_type_for_docstring(schema_class.items))

        elif isinstance(schema_class, avro.schema.MapSchema):
            return "dict[str, {}]".format(
                self.get_type_for_docstring(schema_class.values)
            )

        elif isinstance(
            schema_class, (avro.schema.RecordSchema, avro.schema.EnumSchema)
        ):
            return "{}".format(schema_class.name)

        elif isinstance(schema_class, avro.schema.UnionSchema):
            return " | ".join(
                [self.get_type_for_docstring(s) for s in schema_class.schemas]
            )
        return primatives.get(schema_class.type, schema_class.type)

    def writeConstructor(self, handle):
        """Writes the class constructor

        :param handle: File handle to output
        :type handle:
        """
        # Force using slots to avoid the overhead of a dict per object;
        # when a query returns hundreds of thousands of calls this can
        # save a hundred megabytes or more.

        # organise the fields by whether they are required or not, then by name
        fields = sorted(
            self.getFields(),
            key=lambda x: (
                (
                    x.has_default
                    or (
                        isinstance(x.type, avro.schema.UnionSchema)
                        and "null" in [t.type for t in x.type.schemas]
                    )
                ),
                x.name,
            ),
        )
        if fields:
            self._writeWithIndent("__slots__ = [", handle)
            for field in fields:
                self._writeWithIndent('"{}",'.format(field.name), handle, 2)

            self._writeWithIndent("]", handle, numNewlines=2)
        else:
            self._writeWithIndent("__slots__ = []", handle, numNewlines=2)

        # write initialiser
        self._writeWithIndent("def __init__(", handle)
        self._writeWithIndent("self,", handle, 2)
        for field in fields:
            default = self.get_default(field)

            if field.has_default or default:
                self._writeWithIndent(
                    "{name}={default},".format(name=field.name, default=default),
                    handle,
                    2,
                )
            else:
                self._writeWithIndent(
                    "{name},".format(name=field.name),
                    handle,
                    2,
                )
        self._writeWithIndent(
            "validate=None,",
            handle,
            2,
        )

        self._writeWithIndent(
            "**kwargs",
            handle,
            2,
        )

        self._writeWithIndent("):", handle, 1, 1)

        # add docstring...
        self._writeWithIndent(
            '"""Initialise the {}.{} model.'.format(
                DependencyManager.get_python_package_name(
                    self.dependencies[self.schema.namespace]
                ),
                self.name,
            ),
            handle,
            2,
            numNewlines=2 if fields else 0,
        )
        if fields:
            for field in fields:
                self._writeWithIndent(
                    ":param {name}:".format(name=field.name), handle, 2
                )
                if field.doc:
                    self._writeWithIndent(
                        self._wrappedWithIndent(
                            re.sub(r"[^\x00-\x7F]+", " ", field.doc), 3
                        ),
                        handle,
                        3,
                    )
                self._writeWithIndent(
                    ":type {name}: {types}".format(
                        name=field.name, types=self.get_type_for_docstring(field.type)
                    ),
                    handle,
                    2,
                )

        self._writeWithIndent(
            '"""',
            handle,
            2 if fields else 0,
            2,
        )

        self._writeLines(
            [
                'attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}',
                "ProtocolElement.__init__(self, **attributes)",
            ],
            handle,
            2,
        )

    def write_embedded_namespaces(self, embedded, handle):
        """Returns definition of all embedded namespace in the top level of
        the schema.

        :param embedded: Dictionary of embedded types
        :type embedded: dict[str, Any]
        :param handle: File handle to output
        :type handle:
        """

        embedded["__self__"] = self.schema

        namespaces = sorted(
            list(set(el.namespace for el in embedded.values())),
            key=lambda x: self.dependencies[x]["python_package"],
        )

        lines = [
            "@classmethod",
            "def getEmbeddedByNamespace(cls):",
        ]
        if namespaces:
            lines.append("    # import here to prevent circular imports in python 2.7.")
            for namespace in namespaces:
                package = self.dependencies[namespace]
                lines.extend(
                    [
                        "    from protocols.{} import {} as {}".format(
                            DependencyManager.get_python_protocol_name(
                                {"version": package["build_version"]}
                            ),
                            package["python_package"].lower(),
                            DependencyManager.get_python_package_name(package),
                        ),
                    ]
                )
            lines.append("")

        if embedded:
            lines.append("    return {")

            for fn, et in embedded.items():
                lines.append(
                    self._indent(2)
                    + '"{0}.{1}": {2}.{3},'.format(
                        et.namespace,
                        et.name,
                        DependencyManager.get_python_package_name(
                            self.dependencies[et.namespace]
                        ),
                        et.name,
                    )
                )

            lines.append(self._indent(1) + "}")
        else:
            lines.append("    return {}")
        self._writeLines(lines, handle, numNewlines=1)

    def write_embedded_types_function(self, embedded, group_type, handle):
        """Returns the definition for the _embeddedTypes dictionary. This is a
        temporary mechanism to provide a simple path from the current
        approach to more efficient and type-safe methods that we want
        to transition to.

        :param embedded: Dictionary of embedded types
        :type embedded: dict[str, Any]
        :param group_type : Either Record or Enum
        :type: Literal[RecordSchema, EnumSchema]
        :param handle: File handle to output
        :type handle:
        """

        filtered = {
            name: self.get_schema(et)
            for name, et in embedded.items()
            if isinstance(et, group_type)
        }

        namespaces = sorted(
            list(set(el.namespace for el in filtered.values())),
            key=lambda x: self.dependencies[x]["python_package"],
        )

        lines = [
            "@classmethod",
            "def {}(cls):".format(
                "getEmbeddedTypes"
                if group_type is avro.schema.RecordSchema
                else "getEmbeddedEnums"
            ),
        ]
        if namespaces:
            lines.append("    # import here to prevent circular imports in python 2.7.")
            for namespace in namespaces:
                package = self.dependencies[namespace]
                lines.extend(
                    [
                        "    from protocols.{} import {} as {}".format(
                            DependencyManager.get_python_protocol_name(
                                {"version": package["build_version"]}
                            ),
                            package["python_package"].lower(),
                            DependencyManager.get_python_package_name(package),
                        ),
                    ]
                )
            lines.append("")

        if filtered:
            lines.append("    return {")

            for fn, et in filtered.items():
                lines.append(
                    self._indent(2)
                    + '"{0}": {1}.{2},'.format(
                        fn,
                        DependencyManager.get_python_package_name(
                            self.dependencies[et.namespace]
                        ),
                        et.name,
                    )
                )

            lines.append(self._indent(1) + "}")
        else:
            lines.append("    return {}")
        self._writeLines(lines, handle, numNewlines=1)

    def write(self, output_dir):
        """Writes the class definition to the specified file.

        :param output_dir: File handle to output
        :type output_dir:
        """

        output_path = os.path.join(
            output_dir, "{}_{}.py".format(self.name.lower(), self.schema.type)
        )

        with open(output_path, "w") as handle:
            self.writeHeader(handle)
            # Get the classnames and sort them to get consistent ordering.

            if isinstance(self.schema, avro.schema.EnumSchema):
                superclass = "object"
            elif self.isSearchRequest():
                superclass = "SearchRequest"
            elif self.isSearchResponse():
                superclass = "SearchResponse"
            else:
                superclass = "ProtocolElement"
            self._writeNewline(handle, 2)

            doc = self.schema.doc
            if doc is None or not doc.strip():
                doc = "No documentation"

            self._writeWithIndent(
                "class {0}({1}):".format(self.schema.name, superclass),
                handle,
                indentLevel=0,
            )
            self._writeWithIndent('"""', handle)
            self._writeWrappedWithIndent(re.sub(r"[^\x00-\x7F]+", " ", doc), handle)
            self._writeWithIndent('"""', handle, numNewlines=2)

            if isinstance(self.schema, avro.schema.RecordSchema):
                self._writeLines(
                    [
                        "# load schema from file",
                        "_schemaSource = load_schema(__file__)",
                        "# parse into avro classes",
                        "schema = avro_parse(_schemaSource)",
                    ],
                    handle,
                    numNewlines=1,
                )
                self.writeRequiredFields(handle)
                if self.isSearchResponse():
                    self._writeLines(
                        ['_valueListName = "{0}"'.format(self.getValueListName())],
                        handle,
                    )

                embedded = self.getEmbeddedTypes()

                # records
                self.write_embedded_types_function(
                    embedded,
                    avro.schema.RecordSchema,
                    handle,
                )

                # enums
                self.write_embedded_types_function(
                    embedded,
                    avro.schema.EnumSchema,
                    handle,
                )

                self.write_embedded_namespaces(embedded, handle)

                self.writeConstructor(handle)
            else:
                # TODO make a proper Python enum here using the Python 3.4 enum?
                for symbol in self.schema.symbols:
                    self._writeWithIndent(
                        '{0} = "{0}"'.format(symbol, symbol),
                        handle,
                    )

                self._writeNewline(handle)
                self._writeLines(
                    [
                        "def __hash__(self):",
                        "    return str(self).__hash__()",
                    ],
                    handle,
                )
            versionStr = self.dependencies[self.schema.namespace]["version"]
            versionStr = versionStr.lstrip("v").lstrip("V")
            self._writeLines(
                [
                    "@classmethod",
                    "def _namespace_version(cls):",
                    '    return "{0}"'.format(versionStr),
                ],
                handle,
                numNewlines=0,
            )

    def writeHeader(self, handle):
        """
        Writes the header information to the output file.
        """
        handle.write('"""{0}"""\n'.format(HEADER_COMMENT))
        handle.write("from protocols.protocol import (\n")
        handle.write("    ProtocolElement,\n")

        if self.isSearchRequest():
            handle.write("    SearchRequest,\n")
        if self.isSearchResponse():
            handle.write("    SearchResponse,\n")

        handle.write("    avro_parse,\n")
        handle.write("    load_schema,\n")
        handle.write(")\n")

    def _writeWithIndent(self, string_, handle, indentLevel=1, numNewlines=1):
        indent = " " * (indentLevel * 4)
        toWrite = "{}{}".format(indent, string_).rstrip()

        handle.write(toWrite)
        self._writeNewline(handle, numNewlines)

    def _writeLines(self, lines, handle, indentLevel=1, numNewlines=1):
        indent = " " * (indentLevel * 4)
        handle.writelines(
            ["{}{}\n".format(indent if line.strip() else "", line) for line in lines]
        )
        self._writeNewline(handle, numNewlines)

    def _wrappedWithIndent(self, string_, indentLevel=1):
        return textwrap.fill(
            string_,
            initial_indent="",
            subsequent_indent=" " * (indentLevel * 4),
            break_long_words=False,
            break_on_hyphens=False,
        )

    def _writeWrappedWithIndent(self, string_, handle, indentLevel=1, numNewlines=1):
        self._writeWithIndent(
            self._wrappedWithIndent(string_, indentLevel),
            handle,
            indentLevel=indentLevel,
            numNewlines=numNewlines,
        )

    def _writeNewline(self, handle, numNewlines=1):
        toWrite = "\n" * (numNewlines)
        handle.write(toWrite)

    def _indent(self, count=1):
        return " " * count * 4


class RSTClass(SchemaClass):
    def write(self, output_dir, classes):
        """Writes the schema documentation to the specified file.

        :param output_dir: File handle to output
        :type output_dir:
        :param classes: dict of other clases in model folder
        :type classes: dict[str, RSTClass]
        """

        output_path = os.path.join(
            output_dir, "{}_{}.rst".format(self.name.lower(), self.schema.type)
        )

        package_version = os.path.basename(os.path.dirname(output_dir))

        content = []
        # header
        content.append(
            ".. _{}-{}-{}-{}:\n".format(
                package_version, self.schema.namespace, self.name, self.schema.type
            )
        )
        content.append(self.name)
        content.append("=" * len(self.name))
        content.append("**Namespace:** *{}*".format(self.schema.namespace))
        content.append("\n")

        # prep doc lines
        doc = self.schema.doc if self.schema.doc else "No documentation for model."

        # for bullet point lists, remove extra line breaks
        content.extend(self.parse_doc(doc))
        content.append("\n")

        # if it is a record then build the table
        if isinstance(self.schema, avro.schema.RecordSchema):
            build_version = os.path.basename(os.path.dirname(output_dir))
            # this ensures the rst table lines up
            columns = ["Field", "Type", "Default Value", "Description"]

            field_data = []

            for field in self.getFields():
                doc = field.doc if field.doc else " "
                lines = self.parse_doc(doc)
                # separate lines in doc to lines in rst table
                for i, line in enumerate(lines):
                    avrotype = (
                        self.get_type_for_docstring(field.type, build_version, classes)
                        if i == 0
                        else ""
                    )
                    field_data.append(
                        [
                            field.name if i == 0 else "",
                            avrotype,
                            str(self.get_default(field)) if i == 0 else "",
                            line.strip(),
                        ]
                    )

        else:
            columns = ["Symbols"]
            field_data = [[s] for s in self.schema.symbols]
        column_sizes = [len(c) for c in columns]
        # now increase columns to maximum required size
        for field in [columns] + field_data:
            for c in range(len(columns)):
                if column_sizes[c] < len(field[c]):
                    column_sizes[c] = len(field[c])
        for field in [columns] + field_data:
            for c in range(len(columns)):
                field[c] = field[c] + (" " * (column_sizes[c] - len(field[c])))

        # ensure consisten column widths
        content.append(".. table::")
        content.append(
            "    :widths: {}\n".format(
                " ".join(["20", "20", "10", "50"][0 : len(columns)])
            )
        )

        # now create table

        for i, field in enumerate([columns] + field_data):
            if field[0].strip():
                content.append(
                    "    +-{}-+".format(
                        "-+-".join(["-" * c for c in column_sizes]),
                    )
                )
            content.append("    | {} |".format(" | ".join([c for c in field])))
        content.append("    +-{}-+".format("-+-".join(["-" * c for c in column_sizes])))

        content.append("")

        with open(output_path, "w") as handle:
            handle.write("\n".join(content))

    def get_type_for_docstring(self, schema_class, parent, classes):
        if isinstance(schema_class, avro.schema.ArraySchema):
            return "array<{}>".format(
                self.get_type_for_docstring(schema_class.items, parent, classes)
            )

        elif isinstance(schema_class, avro.schema.MapSchema):
            return "map<{}>".format(
                self.get_type_for_docstring(schema_class.values, parent, classes)
            )

        elif isinstance(
            schema_class, (avro.schema.RecordSchema, avro.schema.EnumSchema)
        ):
            _schema = self.get_schema(schema_class)
            return ":ref:`{0} <{1}-{2}-{0}-{3}>`".format(
                _schema.name,
                self.dependencies[self.schema.namespace]["build_version"],
                _schema.namespace,
                _schema.type,
            )

        elif isinstance(schema_class, avro.schema.UnionSchema):
            return " | ".join(
                [
                    self.get_type_for_docstring(s, parent, classes)
                    for s in schema_class.schemas
                ]
            )

        return schema_class.type

    def get_default(self, field):
        """Returns the default for the provided field.

        :param field: Avro field
        :type field:
        :return: Default
        :rtype: Any
        """
        if field.type.type == "string" or field.type.type == "enum":
            if field.has_default and field.default is not None:
                return '"{}"'.format(field.default)
        elif isinstance(field.type, avro.schema.UnionSchema) and "null" in [
            t.type for t in field.type.schemas
        ]:
            return "null"
        elif field.has_default and field.default is not None:
            if isinstance(field.default, dict):
                return "map"
            if isinstance(field.default, list):
                return "array"
            return field.default
        return ""


class BaseGenerator(object):
    __fileclass__ = PyClass

    def __init__(self, package, dependencies, schemaDir, outputDir):
        """Initialises the generator that builds the python files for model

        :param version: Package data for model
        :type version: dict[str, Any]
        :param dependencies: Dependencies for the model
        :type dependencies: dict[str, Any]
        :param schemaDir: Folder that contains the JSON schema
        :type schemaDir:
        :param outputDir: Output folder path
        :type outputDir: str
        """
        self.package = package

        self.schemaDir = schemaDir
        self.outputDir = outputDir
        self.dependencies = dependencies
        self.classes = {}

        for avscFile in glob.glob(os.path.join(self.schemaDir, "*.avsc")):
            processed_class = self.__fileclass__(avscFile, self.dependencies)

            if processed_class.schema.namespace not in self.dependencies:
                raise KeyError(
                    "{} not in dependency list".format(processed_class.schema.namespace)
                )

            if processed_class.schema.namespace in package["namespaces"]:
                name = processed_class.get_formatted_name(processed_class.schema)
                self.classes[name] = processed_class

                for et in processed_class.getEmbeddedTypes().values():
                    if et.namespace not in self.dependencies:
                        raise KeyError("{} not in dependency list".format(et.namespace))

                    # this ensures no missing types
                    # this was happening previous as the java conversion code ignore enums
                    # with the same name as the record in the same avdl
                    # see metrics ReportedVsGeneticSummary and the enum reportedVsGeneticSummary
                    if (
                        et.namespace in package["namespaces"]
                        and et.namespace not in self.dependencies
                    ):
                        embedded_class = self.__fileclass__(avscFile, self.dependencies)
                        embedded_class.schema = et
                        embedded_class.schemaSource = et.to_json()
                        embedded_class.name = et.name

                        self.classes[embedded_class.get_formatted_name(et)] = (
                            embedded_class
                        )

        requestClassNames = [
            avrocls.schema.name
            for name, avrocls in self.classes.items()
            if avrocls.isSearchRequest()
        ]
        responseClassNames = [
            avrocls.schema.name
            for name, avrocls in self.classes.items()
            if avrocls.isSearchResponse()
        ]
        self.postSignatures = []
        for request, response in zip(requestClassNames, responseClassNames):
            objname = re.search("Search(.+)Request", request).groups()[0]
            url = "/{0}/search".format(objname.lower())
            tup = (url, request, response)
            self.postSignatures.append(tup)
        self.postSignatures.sort()

    def get_parent_module(self):
        return os.path.basename(os.path.dirname(self.outputDir))


class RSTGenerator(BaseGenerator):
    """Class that generates RST files from Avro definitions."""

    __fileclass__ = RSTClass

    def write(self):
        # write out the class files
        for avrocls in self.classes.values():
            avrocls.write(self.outputDir, self.classes)


class PyGenerator(BaseGenerator):
    """Class that generates a schema in Python code from Avro definitions."""

    __fileclass__ = PyClass

    def write_init_imports(self, package, avrocls, avrotype, handle):
        parent_module = self.get_parent_module()
        handle.write(
            "".join(
                [
                    "from protocols.{}.{}.{} import (\n".format(
                        parent_module,
                        package["python_package"],
                        "{}_{}".format(avrocls.lower(), avrotype),
                    ),
                    "    {},\n".format(
                        avrocls,
                    ),
                    ")\n",
                ]
            )
        )

    def write(self):
        """Writes the generated schema classes to the output file."""

        names = sorted(
            [
                name
                for name, avrocls in self.classes.items()
                if avrocls.schema.namespace in self.package["namespaces"]
            ],
            key=lambda x: (
                self.dependencies[self.classes[x].schema.namespace]["python_package"],
                x,
            ),
        )

        # write out the class files
        for name in names:
            avrocls = self.classes[name]
            avrocls.write(self.outputDir)

        handle = os.path.join(self.outputDir, "__init__.py")
        with open(handle, "w") as handle_handle:
            for name in names:
                avrocls = self.classes[name]
                self.write_init_imports(
                    self.dependencies[avrocls.schema.namespace],
                    avrocls.schema.name,
                    avrocls.schema.type,
                    handle_handle,
                )
            handle_handle.write("\n__all__ = [\n")

            for name in names:
                handle_handle.write(
                    '    "{}",\n'.format(self.classes[name].schema.name)
                )
            handle_handle.write("]\n")


class SchemaProcessor(object):
    """Class to download GA4GH schema definitions from github and process these into Python code."""

    def __init__(self, args):
        self.version = args.version
        self.destinationFile = args.handle
        self.verbosity = args.verbose
        self.avroJarPath = args.avro_tools_jar
        self.sourceDir = args.inputSchemasDirectory
        self.schemaDir = self.sourceDir
        self.sourceTar = os.path.join(self.sourceDir, "schemas.tar.gz")
        self.avroJar = os.path.join(self.schemaDir, "avro-tools.jar")

    def cleanup(self):
        if self.verbosity > 0:
            utils.log("Cleaning up dir {}".format(self.sourceDir))
        sources = os.listdir(self.sourceDir)
        for source in sources:
            if source.endswith(".avsc"):
                os.remove(os.path.join(self.sourceDir, source))

    def download(self, url, destination):
        """Downloads the specified url and saves the result to the specified file."""
        fileDownloader = utils.FileDownloader(url, destination)
        fileDownloader.download()

    def convertAvro(self, avdlFile):
        """
        Converts the specified avdl file using the java tools.
        """
        args = ["java", "-jar", self.avroJar, "idl2schemata", avdlFile]
        if self.verbosity > 0:
            utils.log("converting {}".format(avdlFile))
            utils.log("running: {}".format(" ".join(args)))
            # utils.log("working folder {}".format(os.getcwd()))
        if self.verbosity > 0:
            utils.runCommandSplits(args)
        else:
            utils.runCommandSplits(args, silent=True)

    def setupAvroJar(self):
        if self.avroJarPath is not None:
            self.avroJar = os.path.abspath(self.avroJarPath)
        else:
            url = "https://repo1.maven.org/maven2/org/apache/avro/avro-tools/1.11.3/avro-tools-1.11.3.jar"
            self.download(url, self.avroJar)

    def getSchemaFromGitHub(self):
        """Downloads a tagged version of the schemas from the official GitHub repo."""
        url = "https://github.com/ga4gh/schemas/archive/{0}.tar.gz".format(self.version)
        self.download(url, self.sourceTar)
        with tarfile.open(self.sourceTar, "r") as tarball:
            tarball.extractall(self.sourceDir)

    def run(self):
        if self.sourceDir is None:
            self.getSchemaFromGitHub()
        self.setupAvroJar()
        cwd = os.getcwd()
        os.chdir(self.schemaDir)
        for avdlFile in glob.glob("*.avdl"):
            self.convertAvro(avdlFile)
        os.chdir(cwd)
        if self.verbosity > 0:
            utils.log("Writing schemas to {}".format(self.destinationFile))
        sg = PyGenerator(
            self.version, self.schemaDir, self.destinationFile, self.verbosity
        )
        sg.write()
